"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _del = _interopRequireDefault(require("del"));

var _sbFs = _interopRequireDefault(require("sb-fs"));

var _path = _interopRequireDefault(require("path"));

var _pMap = _interopRequireDefault(require("p-map"));

var _makeDir = _interopRequireDefault(require("make-dir"));

var _anymatch = _interopRequireDefault(require("anymatch"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function iterate(_x) {
  return _iterate.apply(this, arguments);
}

function _iterate() {
  _iterate = _asyncToGenerator(function* ({
    extensions,
    rootDirectory,
    sourceDirectory,
    outputDirectory,
    ignored,
    keepExtraFiles,
    filesToKeep,
    callback
  }) {
    const contents = yield _sbFs.default.readdir(sourceDirectory);
    let outputStats;
    let outputDirectoryExists = false;

    try {
      outputStats = yield _sbFs.default.stat(outputDirectory);
    } catch (_) {
      /* No Op */
    }

    if (outputStats) {
      if (outputStats.isDirectory()) {
        outputDirectoryExists = true;
      } else {
        yield (0, _del.default)(outputDirectory);
        outputStats = null;
      }
    }

    const outputContents = outputStats ? yield _sbFs.default.readdir(outputDirectory) : [];

    if (!keepExtraFiles) {
      const whitelist = filesToKeep(contents);
      const filesToDelete = outputContents.filter(item => !whitelist.includes(item)).map(item => _path.default.resolve(outputDirectory, item));
      yield Promise.all(filesToDelete.map(item => (0, _del.default)(item)));
    }

    yield (0, _pMap.default)(contents,
    /*#__PURE__*/
    function () {
      var _ref = _asyncToGenerator(function* (fileName) {
        const filePath = _path.default.join(sourceDirectory, fileName);

        const stat = yield _sbFs.default.lstat(filePath);

        if (stat.isSymbolicLink()) {
          // NOTE: We ignore symlinks
          return;
        }

        if ((0, _anymatch.default)(ignored, fileName) || (0, _anymatch.default)(ignored, filePath) || (0, _anymatch.default)(ignored, _path.default.relative(rootDirectory, filePath))) {
          // NOTE: We ignore ignored files
          return;
        }

        if (stat.isFile()) {
          if (!extensions.includes(_path.default.extname(fileName))) return;

          if (!outputDirectoryExists) {
            yield (0, _makeDir.default)(outputDirectory);
            outputDirectoryExists = true;
          }

          yield callback(filePath, _path.default.join(outputDirectory, fileName), stat);
        } else if (stat.isDirectory()) {
          yield iterate({
            rootDirectory,
            sourceDirectory: _path.default.join(sourceDirectory, fileName),
            outputDirectory: _path.default.join(outputDirectory, fileName),
            ignored,
            keepExtraFiles,
            filesToKeep,
            callback
          });
        }
      });

      return function (_x2) {
        return _ref.apply(this, arguments);
      };
    }());
  });
  return _iterate.apply(this, arguments);
}

var _default = iterate;
exports.default = _default;